#include "config.h"
#include "dt.h"

char *ver = "0.00.08";
char verhi = 0, verlo = 8;
char *copyright = "DummyTosser (c) Dmitry the Zuryanovich, 1997,1998,1999";
char *shortname = "DummyTosser";
//char pktheader[0x3A];
//char msghdr[0x22];
char storedmsghdr[0xBE];
int badmails;
int t_good = 0,t_bad = 0,t_mail = 0,t_send = 0; /* tossed good/bad/netmail */
char outboundpkt[FILENAME_MAX]; /* name of created outbound pkt */
char outboundpkz[FILENAME_MAX]; /* name of created outbound pkzu */
FILE *Foutpkt;/* file of it */


/******************** returns maximal message in echo ********************/
int maximal_message(echo)
char *echo;
{
 char folder[FILENAME_MAX];
 DIR *dirr;
 struct dirent *direntt;
 int maxx,uuu;

 maxx = uuu = 0;
 sprintf(folder,"%s%s",ECHOROOT,echo);
 if (access(folder,F_OK))
 {
  printf("Autocreating area [%s] in [%s]\n",echo,folder);
  if (mkdir(folder,0))
  { printf("Cant create directory,Sux!\n"); return(0);}
  #ifdef _UNIX_PERMISSIONS
  printf("Changing mode\n");
  chmod(folder,0755);  
  #endif
 }
 if (dirr = opendir(folder))
 {
  while (direntt = readdir(dirr))
  {
   /* printf("see %s\n",direntt->d_name);  */
   if (strstr(direntt->d_name,".msg")||strstr(direntt->d_name,".MSG"))
   {
    // printf("%s %u (max.is %u)\n",direntt->d_name,atoi(direntt->d_name),maxx);
    uuu = atoi(direntt->d_name);
    if (uuu > maxx) maxx = uuu;
   }
  }
  closedir(dirr);
  // printf("Counted %u messages\n",maxx);
  return(maxx);
 }else
 {
  printf("Cant open echo %s!\n",folder);return(0);
 }
}

/**************** tosses message, takes open file, called from toss*********/
//char processmsg(F)
char processmsg(unsigned char **F)
{
 int readd,i,msgno,maxmsgg,i1;
 char buffer[FILENAME_MAX];
 char areaname[FILENAME_MAX],*c;
 char msgname[FILENAME_MAX];
 internal_message m1;
// unsigned
 char *msghdr,*curptr,*j;

 clear_message(&m1,0);
 msghdr = (char *)*F;

 curptr = msghdr + 0x22;
 if (!(*msghdr))
 {
   printf("-done\n");return(1);
 }
 if (*(short *)(msghdr) != 2)
 {
  printf("!Message grunged? At least not type 2\n");return(2);
 }
 m1.Dnode = *(short *)(msghdr+4);
 m1.Onode = *(short *)(msghdr+2);
 m1.Dnet = *(short *)(msghdr+8);
 m1.Onet = *(short *)(msghdr+6);
 m1.Dnode = *(short *)(msghdr+4);
 m1.Attr  = *(short *)(msghdr+0x0A);
 m1.Attr &= 0xEF; // message not local
 m1.Attr |= 0x04; // message received

 strncpy(m1.DDate,msghdr+0x0e,20);
 
 strcpy(m1.TTo,curptr);m1.TTo[0x23] = 0;
 curptr += strlen(curptr) + 1;
 strcpy(m1.FFrom,curptr);m1.FFrom[0x23] = 0;
 curptr += strlen(curptr) + 1;
 strcpy(m1.SSubj,curptr);m1.SSubj[71] = 0;
 curptr += strlen(curptr) + 1;

 // printf("Message from %u/%u %s\n",m1.Onet,m1.Onode,m1.FFrom);
 // printf("Message to %u/%u %s\n",m1.Dnet,m1.Dnode,m1.TTo);
 // printf("Message about %s\n",m1.SSubj);

 i = 0;
 while ( (curptr[i]==0x0D) || (curptr[i]==0x0A) ) i++;
 if (!strncmp(curptr+i,"AREA:",5))
 {
   i1 = 0;
   for (i += 5;*(curptr + i + i1) > ' ';i1++);
   //printf("Areatag length is {%u}",i1);
   strncpy(m1.Areatag,curptr+i,i1);
   m1.Areatag[i1] = 0;
   m1.echomail = 1;
 }else
 {
   strcpy(m1.Areatag,"NETMAIL");
   m1.echomail = 0;
 }
// sprintf(msgname,"%s%s/",ECHOROOT,m1.Areatag);
 printf("=> [%s]\n",m1.Areatag);
 m1.Text = strdup(curptr);
 *F = curptr + strlen(curptr) + 1;
// printf("message itsefl: [%s]\n", curptr);
// exit(1);
 #ifdef _LOCAL_KOI8
  toKOI(&m1);
 // printf("message itsefl: %u bytes [%s]\n",strlen(curptr), curptr);
 #endif
 i = write_message_to_folder(&m1,m1.Areatag,0);
 clear_message(&m1,1);
 
 return(i);
}

/*********************************** tosser *******************************/
char toss(pktname)
char *pktname;
{
 FILE *pkt;
 int msgresult;
 char badname[FILENAME_MAX] ;
 int pktlength;
 unsigned char *PktInMemory,*pktheader,*CurMsgPtr;
// printf("* %s : ",pktname);
 #ifdef _UNIX_FILES
 if (!(pkt=fopen(pktname,"r")))
 #else
 if (!(pkt=_fsopen(pktname,"rb",SH_DENYNO)))
 #endif
 {
  printf("!Cant open [%s],sux!\n",pktname);return(0);
 }
 pktlength = lseek(fileno(pkt),0,SEEK_END);
 lseek(fileno(pkt),0,SEEK_SET);
 // printf("Pkt Length is %u\n",pktlength);
 PktInMemory = malloc(pktlength);
 if (!PktInMemory)
 {
  printf("!Cannot allocate [%u] bytes of memory(solution: upgrade from ZX Spectum\n)",pktlength);
  fclose(pkt);
  return(1);
 }
 pktheader = PktInMemory;
 if (pktlength != fread(PktInMemory,1,pktlength,pkt))
 {
  printf("!Cant read [%s] or it is grunged,sux!\n",pktname);fclose(pkt);free(PktInMemory);return(0);
 }
 if ((pktheader[0x28]==pktheader[0x2D])&&(pktheader[0x28]==pktheader[0x2D]))
 {
  printf("+Type 0039 %u:%u/%u.%u => %u:%u/%u.%u\n",
  *(short *)(pktheader+0x2e),*(short *)(pktheader+0x14),*(short *)(pktheader),*(short *)(pktheader+0x32),
  *(short *)(pktheader+0x30),*(short *)(pktheader+0x16),*(short *)(pktheader+2), *(short *)(pktheader+0x34));
 }else
 {
  printf("+Type 0001 %u/%u => %u/%u\n",
  *(short *)(pktheader+14),*(short *)(pktheader),
  *(short *)(pktheader+16),*(short *)(pktheader+2));
 }
 CurMsgPtr = PktInMemory + 0x3A;
 // printf("Message starts from [%u]",*(unsigned short *)CurMsgPtr);
 while  (!(msgresult=processmsg(&CurMsgPtr)));
 fclose(pkt);
 free(PktInMemory);
 if (msgresult==2)
 {
  strcpy(badname,pktname) ;
  strcpy(badname+strlen(badname)-4,".bad");

  printf("+Renaming to %s\n",badname);
  if (rename(pktname,badname))
  {
   printf("!Cant rename %s to %s,sux!\n",pktname,badname);
  }
 }
 if (msgresult==1)
  if (unlink(pktname))
  {
   printf("!Cant unlink %s,sux!\n",pktname);
  }
}
/*************************************************************************/

char processin()
{
 DIR *dirr;
 struct dirent *direntt;
 char fullpktname[FILENAME_MAX];

 if (dirr = opendir(INBOUND))
 {
  while (direntt = readdir(dirr))
  {
   if (strstr(direntt->d_name,".pkt")||strstr(direntt->d_name,".PKT"))
   {
    sprintf(fullpktname,"%s%s",INBOUND,direntt->d_name);
    printf("*[%s]:\n",direntt->d_name);
    if (!access(fullpktname,W_OK|R_OK))
    {
     toss(fullpktname);
    }else
    {
     printf("!No enough rulez to toss %s - skipped\n",fullpktname);
    }
   }
  }
  closedir(dirr);
 }else
 {
  printf("!Cant open inbound %s\n",INBOUND);
 }
}

/******************************* SCANNER **********************************/
CreateOutBoundPkt()
{
 unsigned int i,outname,tries;
 char pktheader[0x3A];

// struct tm *time_structure;
 
// time_structure=localtime(time(0));
// printf("Today is %u year, %s month,%s day",time_structure->tm_year,
//  time_structure->tm_mon,time_structure->tm_mday);
 tries = 0; 
 outname = (MYPOINT << 16 ) + (0x0000FFFF & (unsigned int)time(0));
 do
 {
  sprintf(outboundpkz,"%s%08X.pkz",OUTBOUND,outname++);
  tries++;
  printf("+Creating [%s]\n",outboundpkz);
 }
#ifdef _UNIX_FILES
 while ((tries < 0x00FF) && (!(Foutpkt = fopen(outboundpkz,"w"))));
#else
 while( (tries < 0x00FF) &&  (!(Foutpkt = _fsopen(outboundpkz,"wb",SH_DENYNO))));
#endif
 if (!Foutpkt)
 {
  printf("!This computer is boring. Sell it and buy another one.\n"
         "!(trouble with %s and similar files), suxx!\n",outboundpkz);
  exit(2);
 }
 for (i=0;i<0x3A;i++)*(pktheader+i)=0;
 *(short *)pktheader =  *(short *)(pktheader + 2) = MYNODE;
 *(short *)(pktheader + 0x12) = 2;
 *(short *)(pktheader + 0x14) =  *(short *)(pktheader + 0x16) = MYNET;
 *(pktheader + 0x18) = *(pktheader + 0x2A) = 0xFF; /* product code */
 *(pktheader + 0x19) = *(pktheader + 0x2B) = 0x55; /* product version */
 strcpy(pktheader + 0x1A, PASSWORD);
 *(short *)(pktheader + 0x22) = *(short *)(pktheader + 0x24) =
   *(short *)(pktheader + 0x2E) = *(short *)(pktheader + 0x30) = MYZONE;
 *(short *)(pktheader + 0x32) = MYPOINT ;
 *(short *)(pktheader + 0x34) = 0; /* We are a POINT tosser. Our boss is NODE */
 *(pktheader + 0x2c) = *(pktheader + 0x29) = 1; /*it's a capabiliy word*/
 *(pktheader + 0x18) = 0xFE; /* Product code */
 *(pktheader + 0x2A) = 0; /* the same*/
 *(pktheader + 0x19) = verhi;
 *(pktheader + 0x2B) = verlo;
 
 fwrite(pktheader,1,0x3A,Foutpkt);
}



ThinkOf(msgname,AREATAG)
char *msgname,*AREATAG;
{
 FILE *msg;
 int msgresult;
 char badname[FILENAME_MAX] ;
 internal_message m;
 
 // printf("Thinking of message %s in area %s\n",msgname,AREATAG);
 
 clear_message(&m,0);
 if (!read_message_from_msg(&m,msgname,AREATAG))
 {
  if ( (m.Attr & 0x0100) && (!(m.Attr & 0x0008)))
  { 
   printf("*Sending %s,[%s][%u]\n",msgname,m.Areatag,m.echomail);
   if (!(*outboundpkz))
    CreateOutBoundPkt();
  
   write_message_to_pkt(&m,Foutpkt);
   m.Attr |= 0x0008;
   write_message_to_folder(&m,msgname,1);
 
   t_send++;
  }
  clear_message(&m,1);
 }
}



scan()
{
 DIR *dirr,*echo;
 struct dirent *direntt,*direnttt;
 unsigned int outname,tries;
 char dirname[FILENAME_MAX],msgname[FILENAME_MAX];
 int msgs;

 *outboundpkt = 0;
 if (dirr = opendir(ECHOROOT))
 {
  while (direntt = readdir(dirr))
  {
   if  (strcmp(direntt->d_name,".") && strcmp(direntt->d_name,"..") )
   {
    sprintf(dirname,"%s%s%c",ECHOROOT,direntt->d_name,SLASH);
    if (echo = opendir(dirname))
    {
     msgs = 0;
     printf("+Scanning %s\n",direntt->d_name);
     while(direnttt = readdir(echo))
     { 
      if (strstr(direnttt->d_name,".msg")||strstr(direnttt->d_name,".MSG"))
      {
       sprintf(msgname,"%s%s",dirname,direnttt->d_name);
       //printf("Thinking of %s\n",msgname);
       ThinkOf(msgname,direntt->d_name);
       msgs++;
      }
     }
     printf("+[%s]:[%u]\n",direntt->d_name,msgs);
     closedir(echo);
    }else
    {
     printf("!Cant work with %s\n",dirname);
    }
   }
  }
  if(*outboundpkz)
  {
   fputc(0,Foutpkt);
   fputc(0,Foutpkt);
   // printf("Hey,DtZ, do not forget to write zeroes to outbound pkt!\n");
   fclose(Foutpkt);
   // renaming .pkz to .pkt
   tries = 0; 
   outname = (MYPOINT << 16 ) + (0x0000FFFF & (unsigned int)time(0));
   do
   {
    sprintf(outboundpkt,"%s%08X.pkt",OUTBOUND,outname++);
    tries++;
    printf("+Renaming [%s] => [%s]\n",outboundpkz,outboundpkt);
   }while(rename(outboundpkz,outboundpkt) && (tries<0x7F));
   if (tries == 0x7F) 
   {
    printf("!Suxx! Cannot rename %s to anything sutable\n",outboundpkz);
   }
  }
 }else
 {
  printf("!Cant open %s,suxx!\n",ECHOROOT);
 } 
}
   

main()
{
 char badmaildir[FILENAME_MAX];
 printf(
 "Y82 MAPA3M Research, Hacker's POWER group (HPG),Heffalump Computing presents\n"
 "%s ver %s/%s\n         (avaluable from http://mir.glasnet.ru/~dz/warez)\n",copyright,ver,MYOS);
 sprintf(badmaildir,"%s%s",ECHOROOT,BADMAIL);
 if (access(badmaildir,W_OK|R_OK))
 {
  printf("Cant access BADMAIL directory %s,sux!(create it manually,pls)\n",badmaildir);
  exit(1);
 }
#ifdef _UNIX_FILES
 umask(002);
#endif
 badmails = maximal_message(BADMAIL);
 printf("Badmail ok,with %u messages\n",badmails);
 processin();
 scan();
 printf("Tossed good:[%u], bad:[%u], send:[%u]\n",t_good,t_bad,t_send);
}

